package net.sweevo.jinks.commands;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.mojang.brigadier.context.CommandContext;
import net.minecraft.ChatFormatting;
import net.minecraft.commands.CommandSourceStack;
import net.minecraft.commands.Commands;
import net.minecraft.network.chat.Style;
import net.minecraft.server.level.ServerPlayer;
import net.sweevo.jinks.BackupData;
import net.sweevo.jinks.BackupThread;
import net.sweevo.jinks.ExtBackup;
import net.sweevo.jinks.config.CommonConfig;

public class StatusCommand implements Command<CommandSourceStack> {


    private StatusCommand() {
    }

    public static ArgumentBuilder<CommandSourceStack, ?> register() {
        return Commands.literal("backup")
                .then(Commands.literal("status")
                        .executes(new StatusCommand()));
    }


    @Override
    public int run(CommandContext<CommandSourceStack> context) {
        BackupData data = BackupData.get(context.getSource().getServer());
        String paused = data.isPaused() ? "true" : "false";
        String nextUp = BackupThread.Timer.getTimer(data.getLastSaved() + CommonConfig.getTimer());
        ServerPlayer player = context.getSource().getPlayer();
        if (player != null) {
            player.sendSystemMessage(BackupThread.component(player, "extbackup.status_message", paused, nextUp).withStyle(Style.EMPTY.withColor(ChatFormatting.GOLD)));
        } else {
            ExtBackup.LOGGER.info("Backups paused: {} - Next backup: {}", paused, nextUp);
        }
        return 0;
    }
}
